#include "matrix.h"

int main(int argc, char **argv)
{
   int      m, n;
   matrix   a;

   putchar('\n');
   if (argc != 1) {
      printf("Usage:  %s  [-h]\n\n", argv[0]);
      prn_info(argv[0]);
      exit(1);
   }
   prn_info(argv[0]);
   srand(time(NULL));                                         /* seed rand() */
   for ( ; ; ) {
      printf("Input m and n:  ");
      if (scanf("%d%d", &m, &n) != 2) {
	 printf("\nERROR: Positive integer not found - bye!\n\n");
	 exit(1);
      }
      if (m < 1 || n < 1) {                                   /* normal exit */
	 printf("\nBye!\n\n");
	 exit(0);
      }
      putchar('\n');
      a = get_matrix_space(m, n);
      fill_matrix(a, m, n);
      prn_matrix("A", a, m, n, stdout);
      printf("trace(A) = %g\n\n", trace(a, m, n));
      release_matrix_space(a);
   }
   return 0;
}
